package com.fjhx.xmhjc.controller.topic;

import com.fjhx.xmhjc.service.topic.TopicRepliesService;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.topic.vo.TopicContentVo;
import com.fjhx.xmhjc.entity.topic.dto.TopicContentSelectDto;
import com.fjhx.xmhjc.entity.topic.dto.TopicContentDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.xmhjc.service.topic.TopicContentService;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 * 内容主题 前端控制器
 * </p>
 *
 * @author hj
 * @since 2023-11-20
 */
@RestController
@RequestMapping("/topicContent")
public class TopicContentController {

    @Autowired
    private TopicContentService topicContentService;
    @Resource
    private TopicRepliesService topicRepliesService;

    /**
     * 内容主题列表
     */
    @PostMapping("/list")
    public List<TopicContentVo> list(@RequestBody TopicContentSelectDto dto) {
        return topicContentService.getList(dto);
    }

    /**
     * 内容主题分页
     */
    @PostMapping("/page")
    public Page<TopicContentVo> page(@RequestBody TopicContentSelectDto dto) {
        return topicContentService.getPage(dto);
    }

    /**
     * 内容主题明细
     */
    @PostMapping("/detail")
    public TopicContentVo detail(@RequestBody BaseSelectDto dto) {
        return topicContentService.detail(dto.getId());
    }

    /**
     * 内容主题新增
     */
    @PostMapping("/add")
    public void add(@RequestBody TopicContentDto topicContentDto) {
        topicContentService.add(topicContentDto);
    }

    /**
     * 内容主题编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody TopicContentDto topicContentDto) {
        topicContentService.edit(topicContentDto);
    }

    /**
     * 内容主题删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        topicContentService.delete(dto.getId());
    }

    @PostMapping("/hasReply")
    public Boolean hasReply(@RequestBody TopicContentDto topicContentDto) {
        return topicRepliesService.hasReply(topicContentDto.getId());
    }

}
